Current waiting events  	

Summary
The first and most important script about OWI, is where current sessions waiting

	   SELECT 
	   a.SID, b.serial#, b.status, p.spid, b.logon_time, a.event, l.NAME latch_name, a.SECONDS_IN_WAIT SEC,  
	   b.sql_hash_value, b.osuser, b.username, b.module, b.action, b.program,  
	   a.p1,a.p1raw,  a.p2, a.p3,   --, b.row_wait_obj#, b.row_wait_file#, b.row_wait_block#, b.row_wait_row#, 
	   'alter system kill session ' || '''' || a.SID || ', '|| b.serial# || '''' || ' immediate;' kill_session_sql
	   FROM v$session_wait a, v$session b, v$latchname l, v$process p 
	   WHERE a.SID = b.SID 
	   AND b.username IS NOT NULL 
	   AND b.TYPE <> 'BACKGROUND'
       AND a.event IN ('db file sequential read', 'db file scattered read', 'latch free', 'direct path read', 
       'direct path write', 'enqueue', 'library cache pin', 'library load lock', 'buffer busy waits', 
       'latch: cache buffers chains', 'SQL*Net message from dblink', 'free buffer waits', 'cache buffers chains', 
       'library cache lock', 'global cache open x', 'global cache cr request', 'queue messages')
	   AND (l.latch#(+) = a.p2)
	   AND b.paddr = p.addr
--     and a.sid = 559	    
--	   AND module LIKE '%   ?  @PROM-AS% (TNS V1-V3)%'
--	   and p.spid = 13317
--	   and b.sql_hash_value = '4119097924'
--     and event like 'library cache pin%'
--      AND b.osuser = 'oracle'
--      AND b.username = 'NEREO'
	   ORDER BY a.SECONDS_IN_WAIT DESC; 

Some useful explanations

sid, serial#, status, logon_time, osuser, username, module, action, program: comes from v$session information
kill_session_sql: is the sql statement for killing the session
spid: is the unix process id, in case you want to $>kill -9 spid
sql_hash_value: is the SQL_ADDRESS to identify the SQL statement that is currently being executed. You'll need it for explain plans, etc.
event, latch_name, sec: wait events and how much time is waiting!
p1, p1raw, p2, p3: arguments to find the object related to waiting

Tip: The query filters only the most important wait events!

1.db file sequential read, 
2.db file scattered read 
3.latch free
4.buffer busy waits 
5.cache buffers chains
6.free buffer waits
7.enqueue 
8.direct path read 
9.direct path write 
10.library cache pin
11.library load lock, 
12.library cache locks 
13.global cache open x 
14.global cache cr request
15.queue messages

Other links
Average wait times for all events
How wait times are distributed among events 


Average wait times for all events  	

Summary
All the average times waited for the important wait events.

SELECT event, total_waits, ROUND(100 * (total_waits / sum_waits),2) pct_waits, time_wait_sec,
       ROUND(100 * (time_wait_sec / GREATEST(sum_time_waited,1)),2) pct_time_waited, total_timeouts,
       ROUND(100 * (total_timeouts / GREATEST(sum_timeouts,1)),2) pct_timeouts, average_wait_sec
FROM (SELECT event, total_waits, ROUND((time_waited / 100),2) time_wait_sec, total_timeouts, 
ROUND((average_wait / 100),2) average_wait_sec
FROM sys.v_$system_event 
WHERE event NOT IN 
('lock element cleanup', 'pmon timer', 'rdbms ipc message', 'rdbms ipc reply', 'smon timer', 
 'SQL*Net message from client', 'SQL*Net break/reset to client', 'SQL*Net message to client', 
'SQL*Net more data from client', 'dispatcher timer', 'Null event', 
'parallel query dequeue wait', 'parallel query idle wait - Slaves', 'pipe get',
 'PL/SQL lock timer', 'slave wait', 'virtual circuit status', 'WMON goes to sleep', 
'jobq slave wait', 'Queue Monitor Wait', 'wakeup time manager', 'PX Idle Wait') 
AND event NOT LIKE 'DFS%' 
AND event NOT LIKE 'KXFX%'),
(SELECT SUM(total_waits) sum_waits, SUM(total_timeouts) sum_timeouts, 
SUM(ROUND((time_waited / 100),2)) sum_time_waited
 FROM sys.v_$system_event WHERE event NOT IN 
 ('lock element cleanup', 'pmon timer', 'rdbms ipc message', 'rdbms ipc reply', 
'smon timer', 'SQL*Net message from client', 'SQL*Net break/reset to client', 
'SQL*Net message to client', 'SQL*Net more data from client', 'dispatcher timer',
 'Null event', 'parallel query dequeue wait', 'parallel query idle wait - Slaves', 
'pipe get', 'PL/SQL lock timer', 'slave wait', 'virtual circuit status', 'WMON goes to sleep', 
'jobq slave wait', 'Queue Monitor Wait', 'wakeup time manager', 'PX Idle Wait') 
AND event NOT LIKE 'DFS%' 
AND event NOT LIKE 'KXFX%')
ORDER BY 4 DESC, 1 ASC;

Db file sequential read  	

Summary
The db file sequential read wait event means that Oracle is waiting while doing a single-block I/O read. This is the case when reading an index.

Like all wait events the columns P1, P2, P3 give us the information needed to diagnose the waiting.

Tip: A db sequential read is usually a single-block read, although it is possible to see sequential reads for more than one block (See P3 which is the number of blocks read).
This wait may also be seen for reads from datafile headers (P2=1 indicates a file header read) .

 Parameters:	
    P1 = file#
    P2 = block#
    P3 = blocks

	file#   This is the file# of the file that Oracle is trying to read 
                from. In Oracle8/9 it is the ABSOLUTE file number.

        block#  This is the starting block number in the file from where 
                Oracle starts reading the blocks. Typically only one block is
		being read.

                To find the object that Oracle doing the I/O use one of       
                the two following ways
                 
                SELECT owner, segment_type, segment_name, partition_name,      
                tablespace_name 
	        FROM dba_extents 
	        WHERE :P2 BETWEEN block_id AND (block_id + blocks - 1) 
	        AND file_id = :P1;

                Or even better
                SELECT a.SID, c.obj, c.FILE#, c.dbablk 
	        FROM v$session_wait a, x$bh c 
	        WHERE a.p1 = c.FILE#(+)
	        AND a.p2 = c.dbablk(+) 
	        AND a.event = 'db file sequential read'
	        AND a.SID = :sid_waiting; 

        blocks  This parameter specifies the number of blocks that Oracle is 
                trying to read from the file# starting at block#. This is
		usually "1" but if P3 > 1 then this is a multiblock read.
		Multiblock "db file sequential read"s may be seen in 
		earlier Oracle versions when reading from a SORT (TEMPORARY) 
	        segments. 

 Wait Time:	
    The IO is generally issued as a single IO request to the OS - the wait 
    blocks until the IO request completes.
    Note than an Oracle read request to the OS may be satisfied from an
    OS file system cache so the wait time may be very small.

Some advise
If you see this wait event then general you are in a good position. All the databases (especially the very big systems) have some wait events and doing IO for an index scan is usual.

But SEC (seconds in waiting) from this query must 0 or close to zero (1, 2,3). If you see time waiting to increasing then you must tune the index I/O

How to improve performance for db file sequential read
The steps are, starting from that might come with better results:

1. Rebuild the index (Fast index rebuild)

***To eliminate this case you can exame the state of the index. 
If it is "compact" with no empty holes then there is no need to rebuild it.
 Find index skewed, rebuild
 Find indexes browning, rebuild


2. Tune SQL to use a better index
3. Distribute the index in different filesystems to reduce contention for I/O (Disk I/O)
4. Increase the db_cache_size


Db file scattered read  	

Summary
The db file scattered read wait event means that Oracle is waiting while doing a multiblock IO to complete. This is the case during full table scans or fast full index scans. Oracle can read multiple blocks (up to the initialization parameter db_file_multiblock_read_count) and scatters them into buffers in the buffer cache.

The parameter db_file_multiblock_read_count depends on the platform and the release of Oracle you are running. For exaple for Unix and Linux Systems a good value is 8.

Like all wait events the columns P1, P2, P3 give us the information needed to diagnose the waiting.

 Parameters:	
    P1 = file#
    P2 = block#
    P3 = blocks

	file#   This is the file# of the file that Oracle is trying to read 
                from. In Oracle8/9 it is the ABSOLUTE file number.

        block#  This is the starting block number in the file from where 
                Oracle starts reading the blocks.

                To find the object that Oracle doing the I/O use one of       
                the two following ways
                 
                SELECT owner, segment_type, segment_name, partition_name,      
                tablespace_name 
	        FROM dba_extents 
	        WHERE :P2 BETWEEN block_id AND (block_id + blocks - 1) 
	        AND file_id = :P1;

                Or even better
                SELECT a.SID, c.obj, c.FILE#, c.dbablk 
	        FROM v$session_wait a, x$bh c 
	        WHERE a.p1 = c.FILE#(+)
	        AND a.p2 = c.dbablk(+) 
	        AND a.event = 'db file scattered read'
	        AND a.SID = :sid_waiting; 

        blocks  This parameter specifies the number of blocks that Oracle is 
                trying to read from the file# starting at block#. 

 Wait Time:	
    The wait blocks until all blocks in the IO request have been read.

Some advise
If you see this wait event then general you are NOT in a good position. It is very usual some databases to have wait events and doing IO for a full table or index scan, but can be avoided

START considering to create an index instead of full table scan, if this is not posible, try to imporove the full table or index scan.

How to improve performance for db file scattered read
The steps are, starting from that might come with better results:

1. Move the table to reset table High Water Mark
2. Use Parallel processing
3. Use tablespace with bigger block size
4. If the table has small size change it to IOT
5. Distribute the table or index in different filesystems to reduce contention for I/O (Disk I/O)

Library cache locks  	

Summary
The X$KGLLK table (accessible only as SYS/INTERNAL) contains all the library object locks (both held & requested) for all sessions and is more complete than the V$LOCK view although the column names don't always reveal their meaning.

You can examine the locks requested (and held) by the waiting session by looking up the session address (SADDR) in V$SESSION and doing the following select:

SELECT SADDR FROM V$SESSION WHERE SID = 1843; 
where for example 1843 is the session with the library cache lock wait event
select * from x$kgllk where KGLLKSES = 'C0000001AAFD0758'

This will show you all the library locks held by this session where KGLNAOBJ contains the first 80 characters of the name of the object. The value in KGLLKHDL corresponds with the 'handle address' of the object in METHOD 1.

You will see that at least one lock for the session has KGLLKREQ > 0 which means this is a REQUEST for a lock (thus, the session is waiting). If we now match the KGLLKHDL with the handles of other sessions in X$KGLLK that should give us the address of the blocking session since KGLLKREQ=0 for this session, meaning it HAS the lock.

SELECT * FROM X$KGLLK LOCK_A  
 WHERE KGLLKREQ = 0 
   AND EXISTS (SELECT LOCK_B.KGLLKHDL FROM X$KGLLK LOCK_B 
               WHERE KGLLKSES = 'C0000001A9C32C40' /* BLOCKED SESSION */ 
              AND LOCK_A.KGLLKHDL = LOCK_B.KGLLKHDL 
               AND KGLLKREQ > 0);

If we look a bit further we can then again match KGLLKSES with SADDR in v$session to find further information on the blocking session:

SELECT SID,USERNAME,TERMINAL,PROGRAM FROM V$SESSION 
 WHERE SADDR in  
  (SELECT KGLLKSES FROM X$KGLLK LOCK_A  
   WHERE KGLLKREQ = 0 
     AND EXISTS (SELECT LOCK_B.KGLLKHDL FROM X$KGLLK LOCK_B 
                 WHERE KGLLKSES = 'C0000001A9C32C40' /* BLOCKED SESSION */ 
                 AND LOCK_A.KGLLKHDL = LOCK_B.KGLLKHDL 
                 AND KGLLKREQ > 0));

In the same way we can also find all the blocking sessions:

SELECT USERNAME, SID,SERIAL#,USERNAME,TERMINAL,PROGRAM, MODULE, 
'alter system kill session ' || '''' || SID || ', ' || SERIAL# || '''' || ' immediate;' KILL_SQL 
FROM V$SESSION 
WHERE SADDR IN  
  (SELECT KGLLKSES FROM X$KGLLK LOCK_A  
   WHERE KGLLKREQ > 0 
     AND EXISTS (SELECT LOCK_B.KGLLKHDL FROM X$KGLLK LOCK_B 
                 WHERE KGLLKSES IN (SELECT SADDR FROM V$SESSION 
WHERE SID = :SID_WITH_LIBRARY_CACHE_LOCK) 
                 AND LOCK_A.KGLLKHDL = LOCK_B.KGLLKHDL 
                 AND KGLLKREQ = 0));

Library cache pins  	

Summary
Oracle uses library cache pins to manage library cache concurrency. This tip outlines a method to deal with "library cache pin" wait events that are blocking other users.

For example when someone tries to "grant execute privileges" on a procedure that is currently running may result in library cache pins.

The first step is to see who is waiting for Library Cache Pins, use the scrip for Current waiting events

column P1RAW is the "Handle Address" of the object that is blocking. Execute the following query to get the object's owner and name:

SELECT kglnaown AS owner, kglnaobj AS OBJECT 
FROM sys.x$kglob
WHERE kglhdadr=:p1raw;

Find the sessions that are waiting/blocking on that object.

SELECT 'alter system kill session ' || '''' || s.SID || ', '|| s.serial# || '''' || ' immediate;' kill_session_sql, 
kglpnmod "Mode Held", kglpnreq "Request" 
FROM sys.x$kglpn p, sys.v_$session s 
WHERE p.kglpnuse = s.saddr AND kglpnhdl = :P1RAW 
--AND kglpnreq=0;

Kill the session with Request=0, Mode Held=3 or 2

